$!******************************************************************************
$!
$!==>	Open and read the configuration file for the current user
$!
$	if p1 .eqs. "SETUP"
$	   then
$		_config_file = f$trnlnm("Omi$Config")
$		if _config_file .eqs. "" then $ _config_file = "Sys$Login:Omi$Menu.Cfg"
$		if f$search("''_config_file'") .eqs. "" then -
		   $ _config_file = "Omi$:Omi$Menu.Cfg"
$		if f$search("''_config_file'") .eqs. ""
$		   then
$			write sys$error "Configuration file OMI$MENU.CFG not found"
$			exit omi$_error
$		endif
$	endif
$	if p1 .eqs. "MENU"
$	   then
$		_config_file = p2
$		if _config_file .eqs. ""
$		   then
$			omi$display_message "%OMI-W-NOMENU, no menu specified"
$			exit omi$_warning
$		endif
$		_config_file = f$parse(_config_file,".MNU")
$		_config_file = f$parse(_config_file,,,"name") + f$parse(_config_file,,,"type")
$		if f$trnlnm("Omi$Menu_Directory") .nes. ""
$		   then
$			if f$search("Omi$Menu_Directory:''_config_file'") .nes. ""
$		           then$ _config_file = "Omi$Menu_Directory:''_config_file'"
$		           else $ _config_file = "Omi$:''_config_file'"
$			endif
$	           else $ _config_file = "Omi$:''_config_file'"
$		endif
$		omi$menu_location == f$element(0,":",_config_file) + ":"
$	endif
$!
$	if f$search("''_config_file'") .eqs. ""
$	   then
$		omi$display_message "%OMI-W-NOTFOUND, menu file ''_config_file' not found"
$		exit omi$_warning
$	endif
$	if p3 .eqs. "SETCMD" .or. p3 .eqs. "UPDATE" then -
	   $ open /write omi_config sys$scratch:omi$mnufile_update._tmp$
$	open /read /share=write omi$config '_config_file
$	_section = "main"
$	_update_written = 0
$!
$ readcfg$_loop:
$!
$	read /end_of_file=readcfg$end_loop omi$config _config
$	if p3 .eqs. "SETCMD"
$	   then 
$		gosub config$_setcmd
$		goto readcfg$_loop
$	endif
$!
$	if p3 .eqs. "UPDATE"
$	   then 
$		gosub config$_update
$		goto readcfg$_loop
$	endif
$!
$	_config = f$edit(_config,"uncomment,compress,trim")
$	if _config .eqs. "" then $ goto readcfg$_loop
$	if f$edit(_config,"upcase") .eqs. "<EOF>" then $ goto readcfg$end_loop
$	if f$extract(0, 1, _config) .eqs. "["
$	   then
$		_section = f$edit(f$extract(1, f$length(_config) - 2, -
		   _config), "upcase")
$		if f$extract(0, 5, _section) .eqs. "MENU_" then -
		   $ _section = _section - "MENU_"
$		goto readcfg$_loop
$	endif
$	_item  = f$edit(f$element(0, "=", _config), "trim")
$	_value = f$edit((_config - _item - "="), "trim")
$	_item  = f$edit(_item,"trim")
$	if p3 .eqs. "CLEANUP"
$	   then
$		if f$type('_section'$'_item') .nes. "" then -
		   $ deletee/symbol/global '_section'$'_item'
$	   else
$		if f$type(_value) .eqs. "INTEGER"
$			then $ '_section'$'_item' == f$integer(_value)
$			else $ '_section'$'_item' == "''_value'"
$		endif
$	endif
$	goto readcfg$_loop
$!
$ readcfg$end_loop:
$!
$	close omi$config
$	if p3 .eqs. "SETCMD" .or. p3 .eqs. "UPDATE"
$	   then
$		close omi_config
$		copy /nolog sys$scratch:omi$mnufile_update._tmp$ '_config_file';0
$		delete /nolog /noconfirm sys$scratch:omi$mnufile_update._tmp$;*
$		if p5 .eqs. "RESET" then -
		   deletee/symbol/global 'omi$current_menu'$'p4'
$	endif
$!
$	if  p1 .eqs. "MENU" .and. f$type(menu$item1) .eqs. "" .and. -
	   f$type(menu$input1) .eqs. "" .and. p3 .nes. "CLEANUP"
$	   then
$		omi$display_message "%OMI-E-BADMNU, top menu not defined or empty - invalid menu file"
$		exit omi$_error
$	endif
$	if p3 .eqs. "CLEANUP" .and. f$type(omi$menu_location) .nes. "" -
	   then $ deletee /symbol /global omi$menu_location
$	exit omi$_ok
$!
$!******************************************************************************

$!******************************************************************************
$!
$!==>	A modification to the menu file is requested using the SET command.
$!	This section looks for the current menu (SET can only update in
$!	menu sections) and updates the selected item.
$!
$ config$_setcmd:
$!
$	if f$extract(0, 1, f$edit(_config,"uncomment,compress,trim")) .eqs. "["
$	   then
$		_section = f$edit(f$extract(1, f$length(f$edit(_config,"uncomment,compress,trim")) - 2, f$edit(_config,"uncomment,compress,trim")), "upcase")
$		write omi_config _config
$		return
$	endif
$!
$	if (f$edit(_section,"upcase") - "MENU_") .nes. f$edit(omi$current_menu,"upcase")
$	   then
$		write omi_config _config
$		return
$	endif
$	if f$edit(f$element(0,"=",_config),"upcase,collapse") .eqs. p4 -
 	   then $ return
$	if .not. _update_written .and. p5 .nes. "RESET"
$	   then
$		write omi_config "   ''f$edit(p4,"lowercase")' = ''p5'"
$		'omi$current_menu'$'p4' == "''p5'"
$		_update_written = 1
$	endif
$	write omi_config _config
$!
$	return
$!
$!******************************************************************************

$!******************************************************************************
$!
$!==>	A modification to the menu file is requested using the ENCRYPT command.
$!	This section looks for the selected section and updates the selected
$!	item.
$!
$ config$_update:
$!
$	if f$extract(0, 1, f$edit(_config,"uncomment,compress,trim")) .eqs. "["
$	   then
$		_section = f$edit(f$extract(1, f$length(f$edit(_config,"uncomment,compress,trim")) - 2, f$edit(_config,"uncomment,compress,trim")), "upcase")
$		write omi_config _config
$		return
$	endif
$!
$	if f$edit(_section,"upcase") .nes. f$edit(p4,"upcase")
$	   then
$		write omi_config _config
$		return
$	endif
$!
$	if f$edit(f$element(0,"=",_config),"upcase,collapse") .eqs. -
	   f$edit(p5,"upcase") then $ return
$	if .not. _update_written ! .and. p5 .nes. "RESET"
$	   then
$		write omi_config "   ''f$edit(p5,"lowercase")' = ''p6'"
$		'p4'$'p5' == "''p6'"
$		_update_written = 1
$	endif
$	write omi_config _config
$!
$	return
$!
$!******************************************************************************
