$!******************************************************************************
$!
$!==>	Additional tools for OMI, called by the several internal OMI commands.
$!	These commands will be called whenever one of the OMI commands is
$!	specified in a called module, returning the resulting values in 
$!	global symbols.
$!
$	omi$tb_status = omi$_ok	! Default exit status
$	gosub 'p1'$
$	exit 'omi$tb_status'
$!
$!******************************************************************************

$!******************************************************************************
$!
$!==>	This is a small imported tool, written a few years ago, which does what
$!	'F$EDIT(string,"REVERSE")' should do.
$!	It returns the global symbol OMI$REVERSED, which contains the 
$!	reversed value of the complete input string.
$!
$ reverse$:
$!
$	inputs$ = "''p2' ''p3' ''p4' ''p5' ''p6' ''p7' ''p8'"
$	inputs$ = f$edit(inputs$ ,"trim")
$	if inputs$ .eqs. ""
$	   then
$		omi$tb_status = omi$_error
$		omi$display_message "%OMI-E-IVCALL, invalid call of OMI$REVERSE - no input string specified"
$		return
$	endif
$!
$	ilen$ = f$length(inputs$)
$	ipos$ = 0
$	reversed$ = ""
$!
$ string$_reverse:
$!
$	if ipos$ .lt. ilen$
$	   then
$		rpos$ = ilen$ - ipos$
$		tmp$ = f$extract(ipos$, 1, inputs$)
$		reversed$[rpos$,1] := "''tmp$'"
$!		reversed$[rpos$,1] := f$extract(ipos$, 1, inputs$)
$		ipos$ = ipos$ + 1
$		goto string$_reverse
$	endif
$	omi$reversed == f$edit(reversed$, "trim")
$	return
$!
$!******************************************************************************

$!******************************************************************************
$!
$!==>	An old routine, written a few years ago, imported here to support
$!	mailboxes in OMI. It opens a temporary mailbox for read and write.
$!	The logical pointing to this mailbox is OMI$MAILBOX. There's also a
$!	global symbol with the same name, containing the device name of the
$!	temporary mailbox (MBAxxx:)
$!
$ create_mbx$:
$!
$	if f$trnlnm("Omi$Mailbox") .nes. ""
$	   then
$		omi$display_message "%OMI-W-MBXALREX, invalid call of OMI$CREATE_MBX - mailbox already created"
$		omi$tb_status = omi$_warning
$		return
$	endif
$!
$	omi$display_message "%OMI-I-CREMBX, please wait - creating mailbox"
$!
$	open/write CrMbxSub Sys$Scratch:Omi_CrMbxSub._Tmp$
$	write CrMbxSub -
	   "$ delete/nolog/noconfirm 'f$environment(""procedure"")'"
$	write CrMbxSub "$ define/job _mbox mba'f$getjpi(0,""tmbu"")':"
$	write CrMbxSub -
	   "$ set process/resume/identification='f$getjpi(0,""owner"")'"
$	write CrMbxSub "$ open/read mbx 'f$trnlnm(""_mbox"")'"
$	write CrMbxSub "$ read mbx command"
$	write CrMbxSub "$ close mbx"
$	write CrMbxSub "$ 'command'"
$	close CrMbxSub
$!
$	spawn/nowait/output=nl:/nolog @Sys$Scratch:Omi_CrMbxSub._Tmp$
$	set process/suspended/identification=0
$	omi$mailbox == f$trnlnm("_mbox")
$	open/read/write/share=write/error=crembx$_error -
	   omi$mailbox 'omi$mailbox'
$	deassign/job _mbox
$	write /error=crembx$_error omi$mailbox "exit"
$	omi$msgline_clear
$	return
$!
$ crembx$_error:
$!
$	omi$msgline_clear
$	omi$display_message "%OMI-F-CREMBXERR, error in OMI$CREATE_MBX - cannot create mailbox"
$	if f$trnlnm("Omi$Mailbox") .nes. "" then $ close omi$mailbox
$	omi$tb_status = omi$_error
$	return
$!
$!******************************************************************************

$!******************************************************************************
$!
$!==>	Calculate the current day-, week- and monthnumber. They're returned
$!	as the following global symbols:
$!		omi$daynumber
$!		omi$weeknumber
$!		omi$monthnumber
$!
$ date_info$:
$!
$	if p2 .eqs. "" then $ p2 = "today"
$       months$  = "+#january#31+#february#28+#march#31+#april#30+#may#31+#june#30+#july#31+#august#31+#september#30+#october#31+#november#30+#december#31"
$       year$    = f$integer(f$cvtime(p2,,"year"))
$       imonth$  = f$integer(f$cvtime(p2,,"month"))
$       iday$    = f$integer(f$cvtime(p2,,"day"))
$       year$_4  = (((year$/4)*4 .eq. year$) .and. ((year$/100)*100 .ne. year$))
$       lyear$_4 = ((((year$-1)/4)*4 .eq. (year$-1)) .and. -
	   (((year$-1)/100)*100 .ne. (year$-1)))
$!
$       month$_info = f$element(imonth$,"+",months$)
$       month_of_year$ = f$element( 1, "#", month$_info )
$!
$       month$_counter = imonth$
$!
$ d_info$count_days:
$!
$	if month$_counter .gt. 1
$	   then
$       	month$_counter = month$_counter - 1
$		month$_info = f$element( month$_counter, "+", months$ )
$       	iday$ = iday$ + f$element( 2, "#", month$_info )
$		goto d_info$count_days
$	endif
$!
$       if year$_4 .and. imonth$ .gt. 2 then iday$ = iday$ + 1
$!
$	if f$cvtime(,,"weekday") .eqs. "Monday"    then $ iday$_tmp = iday$ + 9
$	if f$cvtime(,,"weekday") .eqs. "Tuesday"   then $ iday$_tmp = iday$ + 8
$	if f$cvtime(,,"weekday") .eqs. "Wednesday" then $ iday$_tmp = iday$ + 7
$	if f$cvtime(,,"weekday") .eqs. "Thursday"  then $ iday$_tmp = iday$ + 6
$	if f$cvtime(,,"weekday") .eqs. "Friday"    then $ iday$_tmp = iday$ + 5
$	if f$cvtime(,,"weekday") .eqs. "Saturday"  then $ iday$_tmp = iday$ + 4
$	if f$cvtime(,,"weekday") .eqs. "Sunday"    then $ iday$_tmp = iday$ + 3
$!
$       if iday$_tmp .lt. 7
$          then
$       	iday$_tmp = iday$_tmp + 365
$       	if lyear$_4 then $ iday$_tmp = iday$_tmp + 1
$       endif
$       iweek$ = iday$_tmp / 7
$       if iday$_tmp .gt. 371
$          then
$       	iweek$ = 1
$       	if ( iday$_tmp .eq. 372 ) .and. ( year$_4 .or. lyear$_4 ) -
		   then $ iweek$ = 53
$       endif
$!
$	if iday$   .lt. 10 then $ iday$   = "0''iday$'"
$	if iweek$  .lt. 10 then $ iweek$  = "0''iweek$'"
$	if imonth$ .lt. 10 then $ imonth$ = "0''imonth$'"
$!
$	omi$daynumber   == iday$
$	omi$weeknumber  == iweek$
$	omi$monthnumber == imonth$
$!
$	return
$!
$!******************************************************************************

$!******************************************************************************
$!
$!==>	Decrypt an encrypted string. The value will be returned in the global
$!	symbol OMI$DECRYPTED.
$!
$ decrypt$:
$!
$ set message 'omi$_message
$	if p2 .eqs. ""
$	   then
$		omi$tb_status = omi$_error
$		omi$display_message "%OMI-E-IVCALL, invalid call of OMI$DECRYPT - no encrypted string specified"
$		return
$	endif
$s4=""
$s2=-
"''p2'"
$rt1="omi$decrypted"
$r1-
="("
$r2=0
$r3=r2+2
$r4=3*r3
$r5=r4-1
$s5=s4
$11$:
$if -
f$locate-
("("-
,-
s2)-
.lt.-
f$le-
ng-
th(s-
2)
$-
then
$r6="%"-
+-
"''r5'"
$r7=r1+-
"''r2'"
$r6=r1+r6
$s2=-
s2-
--
"''r1'B"-
--
"''r7'"-
--
"''r6'"
$goto-
 11$
$endif
$if(-
f$length-
(s2)*-
4).ge.-
f$length-
(p2)
$then
goto -
13$
$else
$j=-
f$len-
gth(s2-
) -
- 1
$ods=-
f$extract-
(j,1-
,s2)
$if -
ods-
.nes.-
"~".and.-
ods.nes.-
"`" -
then -
goto 13$
$s2-
=f$extr-
act(0,-
j,s2)
$i=0
$16$:
$if -
(i/2-
).eq.(-
(i-
+1)-
/2)
$then
$sl=4
$else
$sl=5
$endif
$s'sl'=-
s'sl'+f-
$ex-
tract(i-
,1,-
s2)
$i=i+1
$if -
i.lt.j -
 then $ goto -
16$
$omi$reverse -
"''s4'"
$s4=-
omi$reversed
$deletee-
/symbol-
/global-
 omi$reversed
$s5=f$extract-
(0,f$length(-
s5)-
--
1,s5)
$if -
ods.eqs.-
"`" -
then -
$s5=-
f$ext-
ract(0,f$l-
ength(s5)--
1-
,s5)
$'rt1'==-
s5+s4
$return
$endif
$-
12$:
$!
$	omi$tb_status = omi$_error
$	omi$display_message "%OMI-E-IVENCR, invalid call of OMI$DECRYPT - invalid string encryption"
$	return
$!
$ 13$:
$!
$	omi$tb_status = omi$_error
$	omi$display_message "%OMI-E-IVFRM, invalid call of OMI$DECRYPT - string has no OMI encryption"
$	return
$!
$!******************************************************************************

$!******************************************************************************
$!
$!==>	An imported older DCL routine which supposed to be unreadable; does
$!	some encryption (very rude, but it works till now).
$!	It reads the first parameter, encrypts it and returns the value in
$!	the global symbol OMI$ENCRYPTED.
$!
$ encrypt$:
$!
$	if p2 .eqs. ""
$	   then
$		omi$tb_status = omi$_error
$		omi$display_message "%OMI-E-IVCALL, invalid call of OMI$ENCRYPT - no string to encrypt specified"
$		return
$	endif
$s1=p2
$gosub -
reverse$
$s5=-
omi$reversed
$deletee-
/symbol-
/global -
omi$reversed
$j=f$le-
ngth(s1)
$if -
(j -
/ 2-
) .eq.-
 (-
(j+-
1) -
/ 2)
$then -
ods=-
"`"
$else -
ods="~"
$endif
$j=(j/-
2)+1
$s8=-
""
$s1=-
f$ex-
tract(0,-
j,s1)
$s5=-
f$ext-
ract(0,j,s5)
$s2=-
"omi$encrypted"
$e1-
=""
$s3=""
$s4=""
$i=5
$e1=e1-
+"("
$l1=i-5
$ods=e1+-
"%''i'"+ods
$i=0
$l2=l1+1
$s9=s8
$ods=ods+-
e1+"B"
$n=0
$gosub 15$
$10$:
$c1=f$-
extract-
(i,1,s8)
$if f$-
extract-
(0,1,f-
$type-
(c1)).eqs.-
"I"
$then
$gosub 20$
$else
$if -
f$-
edit(c1-
,"upcase")-
.eqs.-
"''c1'"
$then
$gosub 20$
$else
$if l1
$then
$gosub 20$
$l1=0
$else
$enc=l1
$l1=1
$endif
$endif
$endif
$gosub 30$
$s9=-
s9+"''e1'B"
$i=i+1
$if i.eq.-
j*2!f$length(p2)
$then
$s9=s9+ods
$'s2'==s9
$return
$endif
$goto -
10$
$20$:
$enc="%5"
$return
$30$:
$s9=s9+-
"''e1'''enc'''c1'"
$return
$15$:
$s8=s8-
+f$extr-
act(n-
,1,s5-
)+f-
$ext-
ract(n,-
1,s1)
$n=n+1
$if n.eq.j
$then
$return
$endif
$goto -
15$
$!
$!******************************************************************************

$!******************************************************************************
$!
$!==>	This rouine checks the existance of the variable.
$!	It returns OMI$_WARNING if the variable is empty, and OMI$_ERROR
$!	if it doesn't exist.
$!	Parameter 'P1' specifies that this routine needs to be called, 'P2'
$!	should contain the parameter that needs to be checked, and 'P3'
$!	optionally contains the message that should be displayed on errors
$!	or warnings.
$!	'P4' can contain the value "EMPTY_ALLOWED" if the variable just has to
$!	exist.
$!
$ check$:
$!
$	if p2 .eqs. ""
$	   then
$		omi$display_message "%OMI-E-IVCALL, invalid call of OMI$CHECK - no variable specified"
$		omi$tb_status = omi$_error
$		return
$	endif
$!
$	if f$type('p2) .eqs. ""
$	   then
$		gosub chkreq$_message
$		omi$tb_status = omi$_error
$		return
$	endif
$!
$	if 'p2 .eqs. ""
$	   then
$		if f$length(p4) .ge. 3 .and. f$edit(p4,"upcase") .eqs. -
		   f$extract(0,f$length(p4), "EMPTY_ALLOWED")
$		   then $ omi$tb_status = omi$_warning
$		   else
$			gosub chkreq$_message
$			omi$tb_status = omi$_warning
$		endif
$		return
$	endif
$	return
$!
$ chkreq$_message:
$!
$	if p3 .eqs. "" then $ return
$	omi$display_message "''p3'"
$	return
$!
$!******************************************************************************

$!******************************************************************************
$!
$!==>	Handle the OMI$CONFIRM command that is defined for use in additional
$!	procedures. This routines returnes the value OMI$CONFIRMED, which can
$!	be true (1) or false (0).
$!
$ confirm$:
$!
$	if f$type(omi$confirmed) .nes. "" then $ deletee/symbol/global omi$confirmed
$!
$	if p3 .nes. ""
$	   then
$		if f$edit(f$extract(0,1,p3),"upcase") .eqs. "Y" .or. -
		   f$edit(f$extract(0,1,p3),"upcase") .eqs. "J"
$		   then
$			p3 = "Y"
$			_def = "([Y]/N) "
$		endif
$		if f$edit(f$extract(0,1,p3),"upcase") .eqs. "N"
$		   then
$			p3 = "N"
$			_def = "(Y/[N]) "
$		endif
$	   else $ _def = "(Y/N) "
$	endif
$	p2 = p2 + " " + _def
$!
$ confirm$_ask:
$!
$	read /end_of_file=confirm$_cancelled sys$command _answer -
	  /prompt="[''screen$line_command';''screen$default_position'H''p2'"
$	omi$msgline_clear
$	omi$cmdline_clear
$	if f$edit(f$extract(0,1,_answer),"upcase") .nes. "Y" .and. -
	   f$edit(f$extract(0,1,_answer),"upcase") .nes. "N" .and. -
	   f$edit(f$extract(0,1,_answer),"upcase") .nes. ""
$	   then
$		omi$display_message "%OMI-W-IVANS, invalid answer - specify Y(es) or N(o)"
$		goto confirm$_ask
$	endif
$	if _answer .eqs. ""
$	   then
$		if p3 .eqs. "Y" then $ omi$confirmed == 1
$		if p3 .eqs. "N" then $ omi$confirmed == 0
$		if p3 .eqs. ""
$		   then
$			omi$display_message "%OMI-W-NODEF, input is required here - there's no default answer"
$			goto confirm$_ask
$		endif
$		return
$	   else
$		if f$edit(f$extract(0,1,_answer),"upcase") .eqs. "Y" then -
		   $ omi$confirmed == 1
$		if f$edit(f$extract(0,1,_answer),"upcase") .eqs. "N" then -
		   $ omi$confirmed == 0
$		return
$	endif
$	
$ confirm$_cancelled:
$!
$	omi$display_message "%OMI-I-INPREQ, input is required here - and that's no bug"
$	omi$cmdline_clear
$	goto confirm$_ask
$!
$!******************************************************************************

$!******************************************************************************
$!
$!==>	Handle the OMI$ASK command that is defined for use in additional
$!	procedures. This routines returnes the value OMI$RESPONSE, which
$!	contains the user response on the question that will be prompted.
$!	If the user entered <Ctrl/Z>, OMI$RESPONSE will be defined empty.
$!	The question is specified in P2. If P2 is not specified, the value
$!	specified in as 'default_input' from the '[questions]' section in
$!	the configuration file will be used.
$!
$ ask$:
$!
$	if p2 .eqs. "" then p2 = "''questions$default_input': "
$!
$ ask$_ask:
$!
$	read /end_of_file=ask$_cancelled sys$command _answer -
	  /prompt="[''screen$line_command';''screen$default_position'H''p2'"
$	omi$msgline_clear
$	omi$cmdline_clear
$	if _answer .eqs. "" then $ goto ask$_ask
$	omi$response == "''_answer'"
$	return
$!
$ ask$_cancelled:
$!
$	omi$response == ""
$	return
$!
$!******************************************************************************

$!******************************************************************************
$!
$!==>	Handle the OMI$INPUT_VALIDATE command, which handles a bug pointed to
$!	by Henry Juengst.
$!
$ input_validate$:
$!
$	if f$type(omi$variable) .eqs. ""
$	   then
$		omi$display_message "%OMI-E-IVCALL, invalid call of OMI$INPUT_VALIDATE - no variable specified"
$		omi$tb_status = omi$_error
$		return
$	endif
$	if .not. omi$_debug then -
	   $ set message /nofacility /noseverity /noidentification /notext
$	if f$locate("'"+"'", 'omi$variable') .lt. f$length('omi$variable')
$	   then $ _stat_on_fail = omi$_error
$	   else
$		if f$locate("'", 'omi$variable') .lt. f$length('omi$variable') -
		   then $ _stat_on_fail = omi$_warning
$	endif
$	if f$type(_stat_on_fail) .eqs. "" then $ return
$	first_quote = f$locate("'", 'omi$variable')
$	_string = 'omi$variable' - "'" - "'" - "'"
$	_string = f$extract(first_quote, f$length(_string) - first_quote, _string)
$!
$	on warning then $ goto string$valid_failed
$	if f$type('_string') .eqs. "" then $ omi$tb_status = _stat_on_fail
$	on warning then $ continue
$	return
$!
$ string$valid_failed:
$!
$	on warning then $ continue
$	omi$tb_status = _stat_on_fail
$	return
$!
$!******************************************************************************

$!******************************************************************************
$!
$!==>	Handle the OMI$WAIT command, where OMI waits for the user to press
$!	<Return>.
$!
$ wait$:
$!
$	read /end_of_file=wait$_cancelled sys$command _dummy -
 	   /prompt="[''screen$line_command';''screen$default_position'H[?25l''questions$wait_prompt' "
$	omi$msgline_clear
$	omi$cmdline_clear
$	ws "[?25h"
$	return
$!
$ wait$_cancelled:
$!
$	ws "[?25h"
$	omi$msgline_clear
$	omi$cmdline_clear
$!	if omi$_verify then $ set verify
$	omi$tb_status = omi$_cancelled
$	return
$!
$!******************************************************************************

$!******************************************************************************
$!
$!==>	This routine is called when OMI exits. It checks for all global
$!	symbols that might have been set by any of the tools, and removes them.
$!
$ cleanup$:
$!
$	if f$type(omi$confirmed) .nes. "" then -
	   $ deletee/symbol/global omi$confirmed
$	if f$type(omi$daynumber) .nes. "" then -
	   $ deletee /symbol /global omi$daynumber   
$	if f$type(omi$weeknumber) .nes. "" then -
	   $ deletee /symbol /global omi$weeknumber  
$	if f$type(omi$monthnumber) .nes. "" then -
	   $ deletee /symbol /global omi$monthnumber 
$	if f$type(omi$reversed) .nes. "" then -
	   $ deletee /symbol /global omi$reversed
$	if f$type(omi$decrypted) .nes. "" then -
	   $ deletee /symbol /global omi$decrypted
$	if f$type(omi$encrypted) .nes. "" then -
	   $ deletee /symbol /global omi$encrypted
$	if f$type(omi$response) .nes. "" then -
	   $ deletee /symbol /global omi$response
$	if f$type(omi$mailbox) .nes. "" then -
	   $ deletee /symbol /global omi$mailbox
$	if f$trnlnm("Omi$Mailbox") .nes. "" then $ close omi$mailbox
$!
$	return
$!
$!******************************************************************************
